export interface CustomElement extends Element {
    connectedCallback?(): void;
    attributeChangedCallback?(name: string, oldValue: string | null, newValue: string | null): void;
    disconnectedCallback?(): void;
    adoptedCallback?(): void;
    formAssociatedCallback?(form: HTMLFormElement): void;
    formDisabledCallback?(disabled: boolean): void;
    formResetCallback?(): void;
    formStateRestoreCallback?(state: unknown, reason: "autocomplete" | "restore"): void;
}
export declare type Constructor<T> = new (...args: any[]) => T;
type ProviderElement = CustomElement & {
    contexts?: Record<PropertyKey, () => unknown>;
    updateContext?(name: string, value: unknown): void;
};
type ConsumerElement = CustomElement & {
    contexts?: Record<PropertyKey, (data: any) => void>;
};
export declare function ProviderMixin<T extends Constructor<ProviderElement>>(Class: T): T & Constructor<ProviderElement>;
export declare function ConsumerMixin<T extends Constructor<ConsumerElement>>(Class: T): T & Constructor<ConsumerElement>;
export {};
