export class ObservableMap {
    #store = new Map;
    set(key, value, subscribers = new Set()) {
        const data = this.#store.get(key);
        subscribers = new Set([...subscribers, ...(data?.subscribers || new Set())]);
        this.#store.set(key, { value, subscribers });
        for (const subscriber of subscribers) {
            subscriber(value);
        }
    }
    get(key) {
        return this.#store.get(key);
    }
}
